377. Combination Sum IV

题目:Combination Sum IV

原题链接:https://leetcode.com/problems/combination-sum-iv/
Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7.

给出一个不重复的正整数序列,用里面的元素相加来得到一个目标正整数,找出一共有多少种解法,注意,不同顺序的序列算两种解法。
例:
给出序列:[1, 2, 3], 目标正整数 4. 那么一共有下面7种解法:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

运用动态规划的方法来求解,设一个数组dp[target + 1],dp[ i ]表示组成 i 的解法,初始dp[ 0 ]设为1,组成0的解法只有一种,对于任意一个 i ,考察组成他的解法来源,对于数列nums中小于等于 i 的任意元素num,组成 i - num 解法是组成 i 的解法的子集,因为只要能够组成i - num ,那么再加上一个num就可以组成 i 。因而组成 i 的所有的解法应该是所有符合条件(就是i >= num)的组成 i - num的解法之和,即dp[ i ] 等于所有dp[ i - num ]之和。

代码如下:

class Solution {
public:
    int combinationSum4(vector<int>& nums, int target) {
        vector<int> dp(target + 1);
        dp[0] = 1;
        for (int i = 1; i <= target; ++i) {
            for(auto num : nums) {
                if(i >= num) dp[i] += dp[i - num];
            }
        }
        return dp[target];
    }
};
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值